﻿const mm = 72/25.4;

var markWeight = 0.25;
var markLength = 5 *mm;
var markOffset = 0 *mm;
var regLength = 10 *mm;
var offsetStr = "Offset reg marx";
var file_privod_crest = "/D/Паша/shablon/priv_crest.pdf";
var file_scale_a2 = "/D/Паша/shablon/scale_a2.pdf";
var file_scale_a3 = "/D/Паша/shablon/scale_a3.pdf";
var file_color = "/D/Паша/shablon/color.pdf";
var size_a2 = 500 * mm;

if ( documents.length > 0 ) {
	doc = activeDocument;
	
	var regColor = new SpotColor();
	regColor.spot = doc.spots['[Registration]'];	
	
	origin = doc.rulerOrigin;
	var start = true;
	
	var privod_crest = new File( file_privod_crest);
	if (doc.width >= size_a2){
		var scale = new File( file_scale_a2);
	}
    else var scale = new File( file_scale_a3);
    
    var clr = new File( file_color);
	var obj = doc.selection;

	if( regOffset = prompt(offsetStr,"0")){
    	regOffset = regOffset * mm;
		var bnd = getBounds(obj);				
		W = bnd[2]-bnd[0];
		H = bnd[1]-bnd[3];
		x1 = bnd[0];
		x2 = bnd[2];
		y1 = bnd[1];
		y2 = bnd[3];
		var mLayer= doc.layers.add();    	 
		mLayer.name = 'regmarx';
		placed = app.activeDocument.placedItems.add();
		placed.file = privod_crest;    	
		var w1 = placed.width;
		var h1 = placed.height;
		line(mLayer,x1 - regOffset, y1, x1 - regLength - regOffset, y1, regColor, 0.25);
		line(mLayer,x2 + regOffset, y1, x2 + regLength + regOffset, y1, regColor, 0.25);
   		if (doc.width >= 500 * mm){
			line(mLayer,(x2 - x1) / 2 + x1, y1 + regOffset, (x2 - x1) / 2 + x1, y1 + regOffset + regLength, regColor, 0.25);
	   	}
 	    x = x1 - w1;
 	    y = y2 + h1;
 	    H = (y1 - y2) / 2 + y2 + h1 / 2;
 	    placed.position = Array(x - regOffset, y1);
 	    placed.duplicate();
 	    placed.position = Array(x2 + regOffset, y1);
 	    placed.duplicate();
 	    placed.position = Array(x - regOffset, y);
 	    placed.duplicate();
 	    placed.position = Array(x2 + regOffset, y);
 	    placed.duplicate();
 	    placed.position = Array(x - regOffset, H);
 	    placed.duplicate();
 	    placed.position = Array(x2 + regOffset, H);
		var embedDoc = new File( clr);
		if ( embedDoc.exists ) {
 		 	var placed = doc.groupItems.createFromFile( embedDoc );
 		 	w1 = placed.width;
 		 	h2 = placed.height;
 		 	placed.position = Array(x1 - regOffset - w1, y2 + h1 + h2); 		 	           
        }        
        placed = app.activeDocument.placedItems.add();
		placed.file = scale;
		w1 = placed.width;
		h1 = placed.height;
		W = (W - w1) /2 + x1;
		placed.position = Array(W, y2 - regOffset);
		mLayer.zOrder(ZOrderMethod.SENDTOBACK);
	}
function line(parent,x1,y1,x2,y2,color,weight) 
{
	var line = parent.pathItems.add();
	line.stroked = true;
	line.filled = false;
	line.strokeWidth = weight;
	line.strokeColor = color;
	line.setEntirePath( Array( Array(x1, y1), Array(x2, y2) ) );
	line = null;
}

function getBounds(obj) {
	var selObj1 = new Array();
	var selObj2 = new Array();
	var vgb1 = new Array();
	var vgb2 = new Array();
	var n = obj.length;
	if (n>0){		
		if( (obj[0].typename == 'GroupItem') && obj[0].clipped && (obj[0].pageItems.length > 1) ){
			clipObj = obj[0].pathItems[0].geometricBounds;
			vgb1 = clipObj;
		}
		else {
			selObj1 = obj[0];
			vgb1 = selObj1.visibleBounds;
		}
		if (n > 1) {
			for (i=1; i<n; i++) {
				selObj2 = obj[i];
				if( (obj[i].typename == 'GroupItem') && obj[i].clipped && (obj[i].pageItems.length > 1) ) {
					vgb2 = obj[i].pathItems[0].geometricBounds;
				}		
				else {
					vgb2 = selObj2.visibleBounds;
				}
				if( vgb1[0] > vgb2[0] ) vgb1[0] = vgb2[0];
				if( vgb1[1] < vgb2[1] ) vgb1[1] = vgb2[1];
				if( vgb1[2] < vgb2[2] ) vgb1[2] = vgb2[2];
				if( vgb1[3] > vgb2[3] ) vgb1[3] = vgb2[3];
			}
		}
	}
	return vgb1;
}
}
